import numpy as np
from matplotlib import pyplot as plt
import cPickle
t=np.linspace(-10,10,num=1e3)
step=1.0*(np.abs(t)<0.5)
#fourier=np.fft.fftshift(np.fft.fft(np.fft.fftshift(f)))
#freq = np.fft.fftfreq(len(fourier))
fourier=np.fft.fft(np.fft.fftshift(step))
fourier=np.fft.fftshift(fourier)
freq=np.fft.fftshift(np.fft.fftfreq(len(step),d=t[1]-t[0]))

data=(t,step,freq,fourier)
cPickle.dump(data,open('data.pkl','w'))
t,step,freq,fourier=cPickle.load(open('data.pkl','r'))
f=plt.figure()
f.subplots_adjust(hspace=0.5)
ax1=f.add_subplot(2,1,1)
ax2=f.add_subplot(2,1,2)
p,=ax1.plot(t,step,'b')
ax1.set_ylim(-0.1,1.5)
ax1.set_xlim(-2,2)
ax1.set_title('Step Function  '+r'$f(t)$')
ax1.set_ylabel(r'$f(\omega)$')
ax1.set_xlabel('x')
ax1.grid(axis='y')



f1,=ax2.plot(freq,fourier.real)
f2,=ax2.plot(freq,fourier.imag)
f1.set_color('b')
f2.set_color('g')
f1.set_label('Real')
f2.set_label('Imag')
f1.set_linestyle('--')
ax2.set_title('FFT')
ax2.set_ylabel(r'$F(\omega)$')
ax2.set_xlabel(r'$\omega(rad/s)$')
t=ax2.title
t.set_color('r')
t.set_fontsize(24)
ax2.axis([-10,10,-20,60])
ax2.legend()
plt.show()

