import numpy as np
import os
from mayavi import mlab


#create figure
mlab.figure(1,bgcolor=(0,0,0))

# The position of the atoms
atoms_x = np.array([2.9, 2.9, 3.8]) * 40 / 5.5
atoms_y = np.array([3.0, 3.0, 3.0]) * 40 / 5.5
atoms_z = np.array([3.8, 2.9, 2.7]) * 40 / 5.5

print 'Atom Oxigen ',atoms_x[1], atoms_y[1], atoms_z[1]
print 'Atom H1 ', atoms_x[0], atoms_y[0], atoms_z[0]
print 'Atom H2', atoms_x[2], atoms_y[2], atoms_z[2]

#plot single atoms
O = mlab.points3d(atoms_x[1], atoms_y[1], atoms_z[1],
                  scale_factor=3,
                  color=(1, 0, 0),
                  scale_mode='none',
                  name='O')

H1 = mlab.points3d(atoms_x[0], atoms_y[0], atoms_z[0],
                   scale_factor=2,
                   color=(1, 1, 1),
                   scale_mode='none',
                   name='H')

H2 = mlab.points3d(atoms_x[2], atoms_y[2], atoms_z[2],
                   scale_factor=2,
                   color=(1, 1, 1),
                   scale_mode='none',
                   name='H')



#Plot the bounds between atoms
mlab.plot3d(atoms_x,atoms_y,atoms_z,[1,2,1],tube_radius=0.3)
mlab.title('H20')

#Plot the localization function
f=file('h2o-elf.cube').readlines()[9:]
data=np.fromstring(' '.join(f),sep=' ')
data=data.reshape((40,40,40))
#using contour 3d
#There are three main ways of visualizing a 3D scalar field
#The problem with this method is that the outer iso-surfaces tend to hide inner ones.
#As a result, quite often only one iso-surface can be visible.
#mlab.contour3d(data)

#Volume rendering is an advanced technique in which each voxel is given a partly transparent color.
#Typically, it can be useful to limit the lower and upper values to the 20 and 80 percentiles of the data
'''obj=mlab.pipeline.scalar_field(data)
vmin=data.min()
vmax=data.max()
mlab.pipeline.volume(obj,vmin=vmin+0.65*(vmax-vmin),vmax=vmin+0.9*(vmax-vmin))
'''
#While less impressive, cut planes are a very informative way of visualizing the details of a scalar field:
p1=mlab.pipeline.image_plane_widget(mlab.pipeline.scalar_field(data),
                                 plane_orientation='x_axes',
                                 slice_index=10)
p2=mlab.pipeline.image_plane_widget(mlab.pipeline.scalar_field(data),
                                 plane_orientation='y_axes',
                                 slice_index=10)
p1.set(visible=False)
mlab.show()

